Loading...
Searching...
No Matches
EST_SingleChannelWave Class Reference

`#include <include/EST_SingleChannelWave.h>`

Inheritance diagram for EST_SingleChannelWave:
[legend]
Collaboration diagram for EST_SingleChannelWave:
[legend]

## Public Member Functions

| EST_SingleChannelWave ()
| default constructor
| EST_SingleChannelWave (const EST_SingleChannelWave &w)
| EST_SingleChannelWave (int n, int sr)
INLINE short & | a_no_check (int i, int channel=0)
INLINE short | a_no_check (int i, int channel=0) const
Public Member Functions inherited from EST_Wave
| EST_Wave ()
| default constructor
| EST_Wave (const EST_Wave &a)
| copy constructor
| EST_Wave (int n, int c, int sr)
| EST_Wave (int samps, int chans, short *memory, int offset=0, int sample_rate=default_sample_rate, int free_when_destroyed=0)
| Construct from memory supplied by caller.
short & | a (int i, int channel=0)
short | a (int i, int channel=0) const
INLINE short & | a_no_check (int i, int channel=0)
INLINE short | a_no_check (int i, int channel=0) const
INLINE short & | a_no_check_1 (int i, int channel=0)
INLINE short | a_no_check_1 (int i, int channel=0) const
INLINE short | set_a (int i, int channel=0, short val=0)
short | operator() (int i, int channel) const
short | operator() (int i) const
short & | a_safe (int i, int channel=0)
float | t (int i) const
| return the time position in seconds of the ith sample
int | num_samples () const
| return the number of samples in the waveform
int | num_channels () const
| return the number of channels in the waveform
int | sample_rate () const
| return the sampling rate (frequency)
void | set_sample_rate (const int n)
| Set sampling rate to n.
int | length () const
| return the size of the waveform, i.e. the number of samples.
float | end ()
| return the time position of the last sample.
bool | have_left_context (unsigned int n) const
| Can we look N samples to the left?
EST_String | sample_type () const
void | set_sample_type (const EST_String t)
EST_String | file_type () const
void | set_file_type (const EST_String t)
EST_String | name () const
| A string identifying the waveform, commonly used to store the filename.
void | set_name (const EST_String n)
| Sets name.
const EST_SMatrix & | values () const
EST_SMatrix & | values ()
void | resize (int num_samples, int num_channels=EST_ALL, int set=1)
| resize the waveform
void | resample (int rate)
| Resample waveform to rate.
void | compress (float mu, float limit)
| Dynamic Range Compression - SaiKrishna May 2017.
void | rescale (float gain, int normalize=0)
void | rescale (const EST_Track &factor_contour)
void | clear ()
| clear waveform and set size to 0.
void | copy (const EST_Wave &from)
void | fill (short v=0, int channel=EST_ALL)
void | empty (int channel=EST_ALL)
void | sample (EST_TVector< short > &sv, int n)
void | channel (EST_TVector< short > &cv, int n)
void | copy_channel (int n, short *buf, int offset=0, int num=EST_ALL) const
void | copy_sample (int n, short *buf, int offset=0, int num=EST_ALL) const
void | set_channel (int n, const short *buf, int offset=0, int num=EST_ALL)
void | set_sample (int n, const short *buf, int offset=0, int num=EST_ALL)
void | sub_wave (EST_Wave &sw, int offset=0, int num=EST_ALL, int start_c=0, int nchan=EST_ALL)
void | sub_wave (EST_Wave &sw, int offset=0, int num=EST_ALL, int start_c=0, int nchan=EST_ALL) const
EST_read_status | load (const EST_String filename, int offset=0, int length=0, int rate=default_sample_rate)
EST_read_status | load (EST_TokenStream &ts, int offset=0, int length=0, int rate=default_sample_rate)
EST_read_status | load (const EST_String filename, const EST_String filetype, int offset=0, int length=0, int rate=default_sample_rate)
EST_read_status | load (EST_TokenStream &ts, const EST_String filetype, int offset=0, int length=0, int rate=default_sample_rate)
EST_read_status | load_file (const EST_String filename, const EST_String filetype, int sample_rate, const EST_String sample_type, int bo, int nc, int offset=0, int length=0)
EST_read_status | load_file (EST_TokenStream &ts, const EST_String filetype, int sample_rate, const EST_String sample_type, int bo, int nc, int offset=0, int length=0)
EST_write_status | save (const EST_String filename, const EST_String EST_filetype="")
EST_write_status | save (FILE *fp, const EST_String EST_filetype="")
EST_write_status | save_file (const EST_String filename, EST_String filetype, EST_String sample_type, int bo, const char *mode="wb")
EST_write_status | save_file (FILE *fp, EST_String filetype, EST_String sample_type, int bo)
EST_write_status | save_file_header (FILE *fp, EST_String ftype, EST_String stype, int obo)
EST_write_status | save_file_data (FILE *fp, EST_String ftype, EST_String stype, int obo)
EST_Wave & | operator= (const EST_Wave &w)
| Assignment operator.
EST_Wave & | operator+= (const EST_Wave &a)
EST_Wave & | operator|= (const EST_Wave &a)
void | integrity () const
Public Member Functions inherited from EST_Featured
int | f_Int (const char *name, int def) const
int | f_Int (const char *name) const
int | f_I (const char *name, int def) const
int | f_I (const char *name) const
void | f_set (const EST_String name, int val)
void | f_set_path (const EST_String name, int val)
float | f_Float (const char *name, float def) const
float | f_Float (const char *name) const
float | f_F (const char *name, float def) const
float | f_F (const char *name) const
void | f_set (const EST_String name, float val)
void | f_set_path (const EST_String name, float val)
EST_String | f_String (const char *name, const EST_String &def) const
EST_String | f_String (const char *name) const
EST_String | f_S (const char *name, const EST_String &def) const
EST_String | f_S (const char *name) const
void | f_set (const EST_String name, const char *val)
void | f_set_path (const EST_String name, const char *val)
const EST_Val & | f_Val (const char *name, const EST_Val &def) const
const EST_Val & | f_Val (const char *name) const
const EST_Val & | f_V (const char *name, const EST_Val &def) const
const EST_Val & | f_V (const char *name) const
void | f_set_val (const EST_String name, EST_Val val)
void | f_set_path (const EST_String name, EST_Val val)
void | f_set (const EST_Features &f)
int | f_present (const EST_String name) const
void | f_remove (const EST_String name)

## Additional Inherited Members

Public Types inherited from EST_Featured
typedef EST_TKVI< EST_String, EST_Val > | FeatEntry
typedef EST_TStructIterator< EST_Featured, IPointer_feat, FeatEntry > | FeatEntries
typedef EST_TRwStructIterator< EST_Featured, IPointer_feat, FeatEntry > | RwFeatEntries
Static Public Attributes inherited from EST_Wave
static const int | default_sample_rate =16000
static const int | default_num_channels
Protected Member Functions inherited from EST_Wave
void | default_vals (int n=0, int c=1)
void | free_wave ()
void | copy_data (const EST_Wave &w)
void | copy_setup (const EST_Wave &w)
Protected Member Functions inherited from EST_Featured
| EST_Featured (const EST_Featured &f)
void | init_features ()
void | copy_features (const EST_Featured &f)
void | clear_features ()
void | ensure_features (void)
void | point_to_first (IPointer_feat &ip) const
void | move_pointer_forwards (IPointer_feat &ip) const
bool | points_to_something (const IPointer_feat &ip) const
EST_TKVI< EST_String, EST_Val > & | points_at (const IPointer_feat &ip)
Protected Attributes inherited from EST_Wave
EST_SMatrix | p_values
int | p_sample_rate

## Detailed Description

An alias for wave which can be used to tell the compiler you know it is a simple one channel wave. This can speed up access.

Author
  Richard Caley rjc@c.nosp@m.str..nosp@m.ed.ac.nosp@m..uk

Version

Id
  EST_SingleChannelWave.h,v 1.2 2001/04/04 13:11:27 awb Exp

Definition at line 47 of file EST_SingleChannelWave.h.

## Constructor & Destructor Documentation

## EST_SingleChannelWave() [1/3]

EST_SingleChannelWave::EST_SingleChannelWave | ( |  | ) |

inline

default constructor

Definition at line 51 of file EST_SingleChannelWave.h.

## EST_SingleChannelWave() [2/3]

EST_SingleChannelWave::EST_SingleChannelWave | ( | const EST_SingleChannelWave & | w | ) |

inline

Definition at line 53 of file EST_SingleChannelWave.h.

## EST_SingleChannelWave() [3/3]

EST_SingleChannelWave::EST_SingleChannelWave | ( | int | n,
|  | int | sr )

inline

Definition at line 55 of file EST_SingleChannelWave.h.

## Member Function Documentation

## a_no_check() [1/2]

INLINE short & EST_SingleChannelWave::a_no_check | ( | int | i,
|  | int | channel = 0 )

inline

Definition at line 57 of file EST_SingleChannelWave.h.

## a_no_check() [2/2]

INLINE short EST_SingleChannelWave::a_no_check | ( | int | i,
|  | int | channel = 0 ) const

inline

Definition at line 59 of file EST_SingleChannelWave.h.

The documentation for this class was generated from the following file:

- include/EST_SingleChannelWave.h